/* Author: Tobi Vollebregt */

/*  Trolls'n Towers: Tobi Vollebregt's TINS Is Not SpeedHack 2005 entry.
 *  Copyright (C) 2005  Tobi Vollebregt
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  See `License.txt', which contains a verbatim copy of the
 *  GNU General Public License, for details.
 *
 *  Please send your reaction to: tobivollebregt@hotmail.com
 */

// copied from BlobLand, an earlier SpeedHack entry (2002) of myself

#include <allegro.h>
#include <string.h>
#include "hiscore.h"
#include "data.h"

const char *const CHiscore::password="we make it not that easy to hack the hiscore data :)";
const char *const CHiscore::filename="hiscore.dat";

DIALOG CHiscore::dialog[]=
{
	{   d_edit_proc, 0,0, 64*8,12, 0,0, 0,D_EXIT, 19,0, NULL,NULL,NULL},
	{   d_text_proc, 0,0, 0,0,     0,0, 0,0,      0,0,  (void*)"Enter your name for hiscore list:",NULL,NULL},
	{   NULL, 0,0, 0,0, 0,0, 0,0, 0,0, NULL, NULL, NULL }
};

CHiscore::CHiscore()
{
	if (!Load()) Reset();
	score = -1;
	bmp = NULL;
	player =0;
	//anim_frame = -1;
}

CHiscore::~CHiscore()
{
	destroy_bitmap(bmp);
	if (player) shutdown_dialog(player);
}

void CHiscore::Reset() { memset(items,0,sizeof(items)); }

bool CHiscore::Load()
{
	packfile_password(password);
	PACKFILE *fp=pack_fopen(filename,"rp");
	if(!fp) return false;
	pack_fread(items,sizeof(items),fp);
	bool ret=(pack_ferror(fp)?false:true);
	pack_fclose(fp);
	packfile_password(NULL);
	return ret;
}

bool CHiscore::Save()
{
	packfile_password(password);
	PACKFILE *fp=pack_fopen(filename,"wp");
	if(!fp) return false;
	pack_fwrite(items,sizeof(items),fp);
	bool ret=(pack_ferror(fp)?false:true);
	pack_fclose(fp);
	packfile_password(NULL);
	return ret;
}

void CHiscore::Add(const char *name, int score)
{
	if(score>items[9].score)
	{
		ustrzcpy(items[9].name,sizeof(items[9].name),name);
		items[9].score=score;
		qsort(items,10,sizeof(Item),qsort_cmp);
	}
}

void CHiscore::InitDialog(int s)
{
	if(s<=items[9].score) {score=-1; return; }

	clear_keybuf();
	memset(name,0,sizeof(name));

	dialog[0].x=dialog[1].x=SCREEN_W/2-dialog[0].w/2;
	dialog[0].y=SCREEN_H/2-dialog[0].h/2;
	dialog[1].y=dialog[0].y-30;
	dialog[0].fg=dialog[1].fg=makecol(255,255,255);
	dialog[0].dp=name;
	score=s;
	player=init_dialog(dialog,0);

	x = double_buffer->w;
	y = double_buffer->h;
	int x2=0, y2=0;

	for (int i =0 ; dialog[i].proc; ++i)
	{
		if (dialog[i].x < x) x = dialog[i].x;
		if (dialog[i].y < y) y = dialog[i].y;
		if (dialog[i].x + dialog[i].w > x2) x2 = dialog[i].x + dialog[i].w;
		if (dialog[i].y + dialog[i].h > y2) y2 = dialog[i].y + dialog[i].h;
	}
	bmp = create_bitmap(x2-x+1, y2-y+1);
	dialog[0].bg = dialog[1].bg=bitmap_mask_color(bmp);

	for (int i =0 ; dialog[i].proc; ++i)
	{
		dialog[i].x -= x;
		dialog[i].y -= y;
	}
}

bool CHiscore::UpdateDialog(BITMAP *buf)
{
	if(score==-1) return false;

	BITMAP *scr=screen;
	clear_to_color(bmp,bitmap_mask_color(bmp));
	screen=bmp;
	dialog[0].flags|=D_DIRTY;
	dialog[1].flags|=D_DIRTY;
	for(int i=0; i<2; i++)
	{
		if(!update_dialog(player))
		{
			while (key[KEY_ENTER]) {}
			clear_keybuf();
			screen=scr;
			Add(name,score);
			shutdown_dialog(player);
			player=NULL;
			return false;
		}
	}
	screen=scr;
	drawing_mode(DRAW_MODE_TRANS, 0, 0, 0);
	set_trans_blender(0, 0, 0, 128);
	rectfill(buf, x-10, y-10, x+bmp->w+10, y + bmp->h+10, 0);
	solid_mode();
	draw_sprite(buf, bmp, x, y);
	return true;
}

static void gray()
{
	double_buffer->clip = FALSE;
	for (int y = 0; y < double_buffer->h; y += 2)
	{
		/*for (int x = (y&2)>>1; x < double_buffer->w; x += 2)
			putpixel(double_buffer, x, y, 0);*/
		hline(double_buffer, 0, y, double_buffer->w-1,0);
	}
	double_buffer->clip = TRUE;
}

extern bool play_again;

bool CHiscore::update()
{
	/*++anim_frame;
	if (anim_frame >= 4*47) anim_frame = 4*47;*/
	if (key[KEY_ENTER]) play_again = true;
	return true;
}

void CHiscore::draw(int, int)
{
	BITMAP* buf = double_buffer;

	if (score != -1)
	{
		//anim_frame = -1;
		if (!UpdateDialog(buf))
		{
			Save();
			score = -1;
		}
	}
	else
	{
		int y=(SCREEN_H-200)/2,x=SCREEN_W/2;

		gray();

		/*drawing_mode(DRAW_MODE_TRANS, 0, 0, 0);
		set_trans_blender(0, 0, 0, 128);
		rectfill(buf, x-128, y-10, x+128, y+130, 0);
		solid_mode();*/

		text_mode(-1);

		for(int i=0; i<SIZEOF(items); i++)
		{
			if(items[i].score==0) break;

			textout_right(buf,font,items[i].name,x+52,y,makecol(255, 255, 255));
			textprintf(buf,font,x+62,y,makecol(255, 255, 255),"%8d",items[i].score);
			y+=20;
		}

		y += 40; 
		textout_centre(buf,font,"Press escape to quit", x,y,makecol(255, 255, 255));
		y += 10;
		textout_centre(buf,font,"Press enter to play again", x,y,makecol(255, 255, 255));
		textout_centre(buf,font, "Made for TINS Is Not SpeedHack 2005", x,double_buffer->h-20,makecol(255,255,255));
		textout_centre(buf,font, "Copyright (C) 2005  Tobi Vollebregt", x,double_buffer->h-10,makecol(255,255,255));

		/*if (anim_frame >= 0)
		{
			RLE_SPRITE* rle = (RLE_SPRITE*) data[TINS0000_BMP+anim_frame/4].dat;
			draw_rle_sprite(buf, rle, double_buffer->w-rle->w, double_buffer->h-rle->h);
		}*/
	}
}
