/* Author: Tobi Vollebregt */

/*  Trolls'n Towers: Tobi Vollebregt's TINS Is Not SpeedHack 2005 entry.
 *  Copyright (C) 2005  Tobi Vollebregt
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  See `License.txt', which contains a verbatim copy of the
 *  GNU General Public License, for details.
 *
 *  Please send your reaction to: tobivollebregt@hotmail.com
 */

#ifndef __tjv_hiscore_h__
#define __tjv_hiscore_h__

#include "object.h"

class CHiscore: public GameObject
{
 public:

	class Item
	{
	 public:

		char name[64];
		int score;
	};

	bool Load();
	bool Save();
	void Add(const char *name, int score);

	void InitDialog(int score);
	bool UpdateDialog(BITMAP *buf);

	void draw(int, int);
	bool update(); // nothing but tins anim

	void Reset();

	CHiscore();
	~CHiscore();

 private:

	static const char *const password;
	static const char *const filename;
	static DIALOG dialog[];

	static int qsort_cmp(const void *e1, const void *e2)
		{ return ((Item *)e2)->score-((Item *)e1)->score; }

	Item items[10];

	DIALOG_PLAYER *player;
	char name[64];
	int score;

	BITMAP* bmp;
	int x, y;
 //   int anim_frame;
};

#endif // !defined(__tjv_hiscore_h__)
