/* Author: Tobi Vollebregt */

/*  Trolls'n Towers: Tobi Vollebregt's TINS Is Not SpeedHack 2005 entry.
 *  Copyright (C) 2005  Tobi Vollebregt
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  See `License.txt', which contains a verbatim copy of the
 *  GNU General Public License, for details.
 *
 *  Please send your reaction to: tobivollebregt@hotmail.com
 */

#include <allegro.h>
#include "map.h"

#define W 100000

/* Original QBASIC code (with some more features actually)
=========================
h! = INT(200 + RND * 150)
hr! = -8.62 + RND * 17.24
FOR i = 0 TO 639
  toeval = INT(RND * 100)
  IF toeval <= 1 AND h! < (water - 80) AND h! > 200 AND plat = 0 AND telflat <= 5 THEN plat = 60
  IF plat = 30 THEN mag(telflat) = i: telflat = telflat + 1
  IF plat = 0 THEN
	h! = h! + hr!
	IF h! > 430 THEN hr! = -1
	IF h! < 100 THEN hr! = 1
	IF h! > 478 THEN h! = 478
	IF h! < 75 THEN h! = 75
	hr! = hr! * .982
	hr! = hr! + (RND - .5)
  END IF
  IF plat > 0 THEN plat = plat - 1
  land(i) = h!
NEXT i
*/

void Map::generate_random()
{
	float h = RANDOM(0.0, 100.0);
	float hr = RANDOM(-1.0, 1.0); //RANDOM(-8.62, 8.62);

	for (int i = 0; i < width; ++i)
	{
		h += hr;
		if ((h < 10 && hr < 0) || (h > 90 && hr > 0)) hr = -0.1 * hr;
		hr *= 0.982;
		hr += RANDOM(-0.3, 0.3);
		height[i] = int(h);
	}
}

Map::Map(): width(W), height(new int[W])
{
	generate_random();
}

Map::~Map()
{
	delete[] height;
}

/*
  IF landkleur = 6 THEN
	IF land(i) > water - 80 THEN
	  gras = land(i) + (land(i) - water + 80) / 3
	  LINE (i, land(i))-(i, gras), 2
	END IF
  END IF
  IF landkleur = 6 OR landkleur = 2 THEN
	IF land(i) > water - 50 THEN
	  gras = land(i) + (land(i) - water + 50) / 2
	  LINE (i, land(i))-(i, gras), 10
	END IF
  END IF
  IF landkleur = 6 OR landkleur = 11 THEN
	IF land(i) < 200 THEN
	  sneeuw = land(i) + (200 - land(i)) / 2
	  LINE (i, land(i))-(i, sneeuw), 15
	END IF
  END IF
*/

void Map::draw(int x, int y)
{
	for (int xc = 0; xc < double_buffer->w; ++xc)
	{
		int h = height[MID(0, x + xc, width-1)];
		int yc = double_buffer->h - h + y;

		if (yc < double_buffer->h)
		{
			vline(double_buffer, xc, yc, double_buffer->h-1, makecol(128, 64, 32));

			if (h > 50)
			{
				int snow = (h + 50) / 2;
				snow = double_buffer->h - snow + y;
				vline(double_buffer, xc, yc, snow, makecol(255, 255, 255));
				circlefill(double_buffer, xc, snow, 1, 0);
			}

			circlefill(double_buffer, xc, yc, 1, 0); //makecol(64, 64, 64));
		}
	}
}
