/* Author: Tobi Vollebregt */

/*  Trolls'n Towers: Tobi Vollebregt's TINS Is Not SpeedHack 2005 entry.
 *  Copyright (C) 2005  Tobi Vollebregt
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  See `License.txt', which contains a verbatim copy of the
 *  GNU General Public License, for details.
 *
 *  Please send your reaction to: tobivollebregt@hotmail.com
 */

#ifndef __tjv_object_h__
#define __tjv_object_h__

#include "debug.h"

class GameObject
{
 public:
	virtual ~GameObject() {}
		// returns true while objects stays `alive'
		// if returns false, object is wiped out
	virtual bool update() { return true; }
		// both have (x,y) params: viewport pos for draw
		// coll det check pos for hit
	virtual void draw(int, int) {}
	virtual bool hit(int, int) { return false; }
};

// assume allegro.h is included before object.h
extern BITMAP* double_buffer;
extern DATAFILE* data;
extern int explosion_color[256];

// from main.cpp
extern void AddGameObject(GameObject*);//W/ collision detection
extern void AddGameObject2(GameObject*);//WO/ collision detection
extern GameObject* GetGameObject(int i);//for collision detection loops
extern int GetNumGameObjects();

#endif // !defined(__tjv_object_h__)
