/* Author: Tobi Vollebregt */

/*  Trolls'n Towers: Tobi Vollebregt's TINS Is Not SpeedHack 2005 entry.
 *  Copyright (C) 2005  Tobi Vollebregt
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  See `License.txt', which contains a verbatim copy of the
 *  GNU General Public License, for details.
 *
 *  Please send your reaction to: tobivollebregt@hotmail.com
 */

#include <allegro.h>
#include <string.h>
#include "particle.h"

#define GRAVITY (-0.1)

Particle::Particle(float X, float Y, float XS, float YS, int LIFETIME, int R, int C):
x(X), y(Y), xs(XS), ys(YS), c(C), r(R), age(0), lifetime(LIFETIME)
{
}

void Particle::draw(int xofs, int yofs)
{
	circlefill(double_buffer, int(x) - xofs,
		double_buffer->h - int(y) + yofs, r * (lifetime - age) / lifetime, c);
}

bool Particle::update()
{
	x += xs;
	y += ys;
	ys += GRAVITY;

	return ++age < lifetime;
}
