/* Author: Tobi Vollebregt */

/*  Trolls'n Towers: Tobi Vollebregt's TINS Is Not SpeedHack 2005 entry.
 *  Copyright (C) 2005  Tobi Vollebregt
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  See `License.txt', which contains a verbatim copy of the
 *  GNU General Public License, for details.
 *
 *  Please send your reaction to: tobivollebregt@hotmail.com
 */

#ifndef __tjv_player_h__
#define __tjv_player_h__

#include "object.h"

class Player: public GameObject // you're an helicopter
{
	float x, y, xs, ys;
	unsigned char rotor, srotor;  // rotor angles (just for animation)
	bool shoot_pressed;
	bool dead;
	bool troll_unlocked;
	int kills;      // number of kills
	int tkills; // kills which count for troll (ie. non-troll-plane-collision-kills)
	int kill_timer; // timeout after 1 sec (50 updates)
	int num_trolls;
	int init_kills; // num kills @ start of interval (kills-init_kills)>boundary gives a monsterkill etc.
	int num_monsterkill;
	float zoom;
 public:
	Player();
	void draw(int, int);
	bool update();
	// return viewport pos calculated from player pos.
	int get_viewport_x() { return int(x+10*xs)-double_buffer->w/4; }
	int get_viewport_y() { return int(y+10*ys)-double_buffer->h/2; }
	float get_x() const { return x; }
	float get_y() const { return y; }
	bool hit(int, int);
	void inckill(bool t=true) { if (kill_timer==0) init_kills = kills; ++kills; if(t)tkills++; kill_timer = 50; }
	bool is_dead() const { return dead; }
	int getkills() { return kills; }
};

extern Player* the_player;

#endif // !defined(__tjv_player_h__)
