/* Author: Tobi Vollebregt */

/*  Trolls'n Towers: Tobi Vollebregt's TINS Is Not SpeedHack 2005 entry.
 *  Copyright (C) 2005  Tobi Vollebregt
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  See `License.txt', which contains a verbatim copy of the
 *  GNU General Public License, for details.
 *
 *  Please send your reaction to: tobivollebregt@hotmail.com
 */

#include <allegro.h>
#include "rocket.h"
#include "particle.h"
#include "player.h"

#define ACCEL 1.0
#define LENG 10

Rocket::Rocket(float X, float Y, float XS, float YS): x(X), y(Y), xs(XS), ys(YS) {}

void Rocket::draw(int xofs, int yofs)
{
	hline(double_buffer, int(x)-xofs-LENG/2, double_buffer->h-int(y)+yofs,
		int(x)-xofs+LENG/2, makecol(255, 255, 255));
}

bool Rocket::update()
{
	GameObject* obj;
	bool ret = true;
	for (int i = 0; i < GetNumGameObjects(); ++i)
	{
		if ((obj = GetGameObject(i)) && obj != the_player && obj->hit(int(x), int(y))) ret = false;
	}
	if (!ret)
	{
		for (int i = 0; i < 10; ++i)
		{
			AddGameObject2(new Particle(int(x),int(y),RANDOM(-2.0,2.0),RANDOM(-2.0,2.0),40,10,
				explosion_color[rand()&255]));
		}
		return ret;
	}

	x += xs;
	y += ys;
	if (xs < 15.0) xs += ACCEL;
	ys *= 0.95;

	AddGameObject2(new Particle(x-LENG, y, RANDOM(-1.0, 0.0), RANDOM(-1.0, 1.0), 25, 5, makecol(128, 128, 128)));
	return x < the_player->get_x() + double_buffer->w;
}
